jQuery(document).ready(function () {
	// BOTONES DE TABLA PRODUCTOS
	$("#btn_tbl_productos_add").click(function (e) {
		e.preventDefault();
		document.getElementById("form_add_productos").reset();
		$("#modal_productos_add").modal("show");
		var tasa = $("#tasa").html();
		var tasa = $('input[name="tasa_productos"]').val(tasa);
	});

	$("#btn_tbl_productos_edit").click(function () {
		var resultJSON = $("#tbl_productos").bootstrapTable("getSelections");
		var seleccion = $('input[name="rtbl_productos"]:checked').length;
		if (seleccion == 0) {
		//epsToast ( color,text-color, icon, head, headsmall, mensaje, boton )
			epsToast(
				"danger",
				"white",
				'<i class="bi bi-hdd"></i>',
				"Seleccion",
				"Error",
				"Seleccione un item de la tabla.",
				"bottom"
				);
			return false;
		} else {
			document.getElementById("form_edit_productos").reset();
			var ref = resultJSON[0]["id"];
			fill_input_productos(resultJSON[0]);
		// var query= JSON.stringify(resultJSON);
			$("#modal_productos_edit").modal("show");
			var tasa = $("#tasa").html();
			var tasa = $('input[name="tasa_edit"]').val(tasa);
		}
	});

	$("#btn_tbl_productos_send").click(function () {
		var resultJSON = $("#tbl_productos").bootstrapTable("getSelections");
		var seleccion = $('input[name="rtbl_productos"]:checked').length;
		if (seleccion == 0) {
			epsToast(
				"danger",
				"white",
				'<i class="bi bi-hdd"></i>',
				"Seleccion",
				"Error",
				"Seleccione un item de la tabla.",
				"bottom"
				);
			return false;
		} else {
			var ref = resultJSON[0]["id"];
			var resultJSON = $("#tbl_productos").bootstrapTable("getSelections");
			var html_documento = $("#html_documento").html();

			if (html_documento === "Compras") {
				fill_tblar_compras(resultJSON[0]);
			} else {
				fill_tblar(resultJSON[0]);
			}
		}
	});

	// FORMULARIOS
	$("#form_add_productos").submit(function (e) {
		e.preventDefault();
		var f = $(this);
		var formData = new FormData(document.getElementById("form_add_productos"));

		$.ajax({
			url: base_url + "productos/add_productos",
			type: "POST",
			dataType: "JSON",
			data: formData,
			cache: false,
			contentType: false,
			processData: false,
			beforeSend: function () {
				$("#loader").removeClass("display-none");
			},
			success: function (r) {
			//var r = JSON.parse(respuesta);
			//console.log(r);

				epsToast(
					"light",
					"dark",
					'<i class="bi bi-check2"></i>',
					"" + r.success,
					"" + r.data.id,
					"",
					"" + r.mensaje
					);

				$("#tbl_productos").bootstrapTable("refresh", {
					url: base_url + "productos/listaproductos",
				});

				$("#modal_productos_add").modal("hide");
				//window.location.href = base_url + "productos/productos_list/";

			},
			error: function (jqXHR, textStatus, error) {
				epsToast(
					"danger",
					'<i class="bi bi-x-octagon"></i>',
					jqXHR,
					jqXHR.status,
					jqXHR.responseText,
					""
					);
				clearTimeout();
//setTimeout(function(){ location.reload(); }, 10000);
			},
			complete: function () {
				$("#loader").addClass("display-none");

//setTimeout(function(){ $('#loader').addClass('display-none'); }, 4000);
			},
		});
	});

	$("#form_edit_productos").submit(function (e) {
		e.preventDefault();
		var f = $(this);
		var formData = new FormData(document.getElementById("form_edit_productos"));


		$.ajax({
			url: base_url + "productos/edit_productos",
			type: "POST",
			dataType: "JSON",
			data: formData,
			cache: false,
			contentType: false,
			processData: false,
			beforeSend: function () {
				$("#loader").removeClass("display-none");
			},
			success: function (r) {
				epsToast(
					"light", "dark", '<i class="bi bi-check2"></i>',
					"" + r.success,
					"" + r.data.id,
					"",
					"" + r.mensaje
					);

				$("#tbl_productos").bootstrapTable("refresh", {
					url: base_url + "productos/listaproductos",
				});

				$("#modal_productos_edit").modal("hide");

			},
			error: function (jqXHR, textStatus, error) {
				epsToast(
					"danger",
					'<i class="bi bi-x-octagon"></i>',
					jqXHR,
					jqXHR.status,
					jqXHR.responseText,
					""
					);
				clearTimeout();
			},
			complete: function () {
				$("#loader").addClass("display-none");
			},
		});
	});

});


// CALCULO DE PRECIOS DOLAR BS EN FORM ADD ARTICULOS
$('input[name="precio_d"]').change(function () {
	calc_bs();
});
function calc_bs() {
	var tasa = $('input[name="tasa_productos"]').val();
	tasa = parseFloat(tasa).toFixed(2);
	var precio_d = $('input[name="precio_d"]').val();
	precio_d = parseFloat(precio_d).toFixed(2);
	var precio = tasa * precio_d;
	precio = precio.toFixed(2);
	$('input[name="precio_bs"]').val(precio);
}
$('input[name="precio_bs"]').change(function () {
	calc_d();
});
function calc_d() {
//var tasa = $("#tasa").html();
	var tasa = $('input[name="tasa_productos"]').val();
	tasa = parseFloat(tasa).toFixed(2);
	var precio_bs = $('input[name="precio_bs"]').val();
	precio_bs = parseFloat(precio_bs).toFixed(2);
	var precio = precio_bs / tasa;
	precio = precio.toFixed(2);

	$('input[name="precio_d"]').val(precio);
//$('input[name="tasa"]').val(tasa);
}
$('input[name="tasa_productos"]').change(function () {
	calc_bs();
});



// CALCULO DE PRECIOS DOLAR BS EN FORM EDIT PRODUCTOS
$('input[name="precio_d_edit"]').change(function () {
	calc_bs_edit();
});
function calc_bs_edit() {
	var tasa = $('input[name="tasa_productos_edit"]').val();
	tasa = parseFloat(tasa).toFixed(2);
	var precio_d = $('input[name="precio_d_edit"]').val();
	precio_d = parseFloat(precio_d).toFixed(2);
	var precio = tasa * precio_d;
	precio = precio.toFixed(2);
	$('input[name="precio_bs_edit"]').val(precio);
}
$('input[name="precio_bs_edit"]').change(function () {
	calc_d_edit();
});
function calc_d_edit() {
//var tasa = $("#tasa").html();
	var tasa = $('input[name="tasa_productos_edit"]').val();
	tasa = parseFloat(tasa).toFixed(2);
	var precio_bs = $('input[name="precio_bs_edit"]').val();
	precio_bs = parseFloat(precio_bs).toFixed(2);
	var precio = precio_bs / tasa;
	precio = precio.toFixed(2);

	$('input[name="precio_d_edit"]').val(precio);
//$('input[name="tasa"]').val(tasa);
}
$('input[name="tasa_productos_edit"]').change(function () {
	calc_bs_edit();
});



// FILL INPUT PRODUCTOS
function fill_input_productos(data) {
/*$('input[name="id_inventario"]').val(data.id_inventario);
var t = data.rif;
var rif = t.substring(1);
var j = t.charAt(0);*/

//$('#select_j').val(j);

	$('input[name="id_producto"]').val(data.id);
//$('input[name="documento"]').val(data.documento);
	$('input[name="id"]').val(data.id);
	$('input[name="codigo"]').val(data.codigo);
	$('input[name="descripcion"]').val(data.descripcion);
	$('input[name="stock"]').val(data.stock);
	$('input[name="costo"]').val(data.costo);
	$('input[name="precio_d"]').val(data.precio_d);
	$('input[name="precio_bs"]').val(data.precio_bs);


	$('input[name="costo_d_edit"]').val(data.costo_d);
	$('input[name="precio_d_edit"]').val(data.precio_d);
	$('input[name="precio_bs_edit"]').val(data.precio_bs);
	$('input[name="tasa"]').val(data.tasa);
	$('input[name="tasa_productos_edit"]').val(data.tasa);
	$('input[name="excento"]').val(data.excento);
	$("#condicion_edit").val(data.condicion);
	$("#categoria_edit").val(data.categoria);
	$('input[name="compatible_con"]').val(data.compatible_con);


	var url = base_url + 'assets/epscolor/img/productos/' + data.foto+'?'+ Math.random();
	$('#img_file_input_foto_edit').prop("src", url);
   

   if (data.tienda === "1") { 
      document.getElementById("check_tienda_edit").checked = true;} 
   else { document.getElementById("check_tienda_edit").checked = false;}

   //limpiar img_file_input_foto_edit_ver
   clearFileInput(document.getElementById("file_input_foto_edit"));
   $("#img_file_input_foto_edit_ver").attr("src", '');
	


	var f = Date.parse(data.created_at);
	if (isNaN(f) == false) {
		var f = new Date(data.created_at);
		var d = new Date(f - f.getTimezoneOffset() * 60000);
		f = d.toISOString();
		$('input[name="created_at"]').val(f.substring(0, f.length - 1));
	}


}

function clearFileInput(ctrl) {
	try {
		ctrl.value = null;
	} catch(ex) { }
	if (ctrl.value) {
		ctrl.parentNode.replaceChild(ctrl.cloneNode(true), ctrl);
	}
}

// FILL INPUT ARTICULOS
function fill_input_art(data) {
	$('input[name="id_art"]').val(data.id);
	$('input[name="id_art"]').val(data.id_producto);
	$('input[name="cantidad_art"]').val(data.cantidad);
	$('input[name="codigo_art"]').val(data.codigo);
	$('input[name="descripcion_art"]').val(data.descripcion);
	$('input[name="costo_d_art"]').val(data.costo_d);
	$('input[name="precio_d_art"]').val(data.precio_d);
	$('input[name="precio_bs_art"]').val(data.precio_bs);
	$('input[name="tasa_art"]').val(data.tasa);
	$("#categoria_edit_art").val(data.categoria);
	$("#condicion_edit_art").val(data.condicion);

//if (data.excento === "1") { $("#excento_art").attr("checked", true);}
//$('input[name="excento_art"]').val(data.excento);
}


// FILL TABLA ARTICULOS
function fill_tblar(data) {
	var subtotal_d = data["precio_d"];
	var costo_d = data["costo_d"];
	var tasa = $("#tasa").html();
	tasa = parseFloat(tasa).toFixed(2);

	var precio_bs = subtotal_d * tasa;
	precio_bs = parseFloat(precio_bs).toFixed(2);

	$("#tblar").bootstrapTable("append", [
	{
		id_producto: data["id"],
		codigo: data["codigo"],
		descripcion: data["descripcion"],
		stock: data["stock"],
		cantidad: "1",
		costo_d: data["costo_d"],
		precio_d: data["precio_d"],
		precio_bs: precio_bs,
		tasa: tasa,
		subtotal_d: subtotal_d,
		condicion: data["condicion"],
		categoria: data["categoria"],
	},
	])
	.data("2");

	var resultJSON2 = $("#tblarto").bootstrapTable("getData");
	var len3 = resultJSON2.length;
	if (len3 == 0) {
		$("#tblarto")
		.bootstrapTable("append", [
		{
			subtotal_d: "",
			iva: "",
			total: "",
		},
		])
		.data("2");
	}

	calc_to_tblar();

	epsToast( "info", "dark", '<i class="bi bi-hdd"></i>', "Item", "Send", "Articulo enviado a la tabla de trabajo", "bottom");
}



	// CALCULAR TOTALES TABLA ARTICULOS
	function calc_to_tblar() {
		var resultJSON = $("#tblar").bootstrapTable("getData");
		var sum_subtotal_d = 0;
		//var iva = 0.09
		var iva = $("#select_iva").val();
		iva = parseFloat(iva) / 100;

		for (var len = resultJSON.length, i = 0; i < len; i++) {
			// for each object in the list
			var item = resultJSON[i];
			sum_subtotal_d += parseFloat(item.subtotal_d, 10); // parse its "bvo" element as integer and add it to the sum
		}
		sum_subtotal_d = parseFloat(sum_subtotal_d).toFixed(2);

		iva = iva * sum_subtotal_d;
		iva = parseFloat(iva).toFixed(2);

		var subtotal_d = sum_subtotal_d;
		var total_d = parseFloat(iva) + parseFloat(sum_subtotal_d);
		total_d = parseFloat(total_d).toFixed(2);

		$("#tblarto").bootstrapTable("updateRow", {
			index: 0,
			row: {
				subtotal_d: subtotal_d,
				iva: iva,
				total_d: total_d,
			},
		});

	}


// TABLA ARTICULOS 
$("#btn_tblar_edit").click(function () {
	var resultJSON = $("#tblar").bootstrapTable("getSelections");
	var item = $('input[name="rtblar"]:checked').length;

	if (item == 0) {
		epsToast(
			"danger",
			"white",
			'<i class="bi bi-hdd"></i>',
			"Seleccion",
			"Error",
			"Seleccione un item de la tabla.",
			"bottom"
			);

		return false;
	} else {
		var codigo = resultJSON[0]["codigo"];
		fill_input_art(resultJSON[0]);
//calc_bs();
		$("#modal_productos_art_edit").modal("show");
		return false;
	}
});


$("#btn_tblar_del").click(function () {
	var resultJSON = $("#tblar").bootstrapTable("getSelections");
	var item = $('input[name="rtblar"]:checked').length;

	if (item == 0) {
		epsToast(
			"danger",
			"white",
			'<i class="bi bi-hdd"></i>',
			"Seleccion",
			"Error",
			"Seleccione un item de la tabla.",
			"bottom"
			);
		return false;
	} else {
		var selects = $("#tblar").bootstrapTable("getSelections");

		ids = $.map(selects, function (row) {
			return row.id_producto;
		});

		$("#tblar").bootstrapTable("remove", {
			field: "id_producto",
			values: ids,
		});
		calc_to_tblar();
		return false;
	}
});


$("#btn_art_env").click(function () {
	var html_documento = $("#html_documento").html();

	var codigo = $("input[name='codigo_art']").val();
	var descripcion = $("input[name='descripcion_art']").val();
	var cantidad = $("input[name='cantidad_art']").val();
	var costo = $("input[name='costo_d_art']").val();
	var precio_d = $("input[name='precio_d_art']").val();
	var precio_bs = $("input[name='precio_bs_art']").val();
	var categoria = $("input[name='categoria_art']").val();
	var condicion = $("input[name='condicion_art']").val();
	var excento = $("input[name='excento_art']").val();
	var tasa = $("input[name='tasa_art']").val();

	if (html_documento === "Compras") {
		var subtotal_d = cantidad * costo;
		subtotal_d = parseFloat(subtotal_d).toFixed(2);
	} else {
		var subtotal_d = cantidad * precio_d;
		subtotal_d = parseFloat(subtotal_d).toFixed(2);
	}

	var rowindex = "";
	$('input[name="rtblar"]:checked').each(function () {
		rowindex = $(this).data("index");
	});

	$("#tblar").bootstrapTable("updateRow", {
		index: rowindex,
		row: {
			codigo: codigo,
			descripcion: descripcion,
			cantidad: cantidad,
			costo: costo,
			precio_d: precio_d,
			precio_bs: precio_bs,
			subtotal_d: subtotal_d,
			categoria: categoria,
			condicion: condicion,
			tasa: tasa,
		},
	});
	$("#modal_productos_art_edit").modal("hide");
	calc_to_tblar();
});


$("#btn_calc_to_tblar").click(function () {
	var $table = $('#tblar')
	var resultJSON2 = $("#tblar").bootstrapTable("getData");

	//alert (resultJSON2[0].id);

	var newvalue = '';
    for (var i=0; i<resultJSON2.length; i++){
      if (resultJSON2[i].subtotal_d){
      	newvalue = resultJSON2[i].costo_d * resultJSON2[i].cantidad;
        resultJSON2[i].subtotal_d = newvalue;

          $("#tblar").bootstrapTable("updateRow", {
		    index: i,
		    row: {
		      subtotal_d: newvalue,
		    },
		  });
      }
    }
    alert (JSON.stringify(resultJSON2));
		calc_to_tblar();
		return false;
});


//CALCULOS DE PRECIOS ARTICULOS COMUN
$('input[name="precio_d_art"]').change(function () {
	calc_bs_art();
});
function calc_bs_art() {
	var tasa = $('input[name="tasa_art"]').val();
	tasa = parseFloat(tasa).toFixed(2);
	var precio_d = $('input[name="precio_d_art"]').val();
	precio_d = parseFloat(precio_d).toFixed(2);
	var precio = tasa * precio_d;
	precio = precio.toFixed(2);
	$('input[name="precio_bs_art"]').val(precio);
}
$('input[name="precio_bs_art"]').change(function () {
	calc_d_art();
});
function calc_d_art() {
//var tasa = $("#tasa").html();
	var tasa = $('input[name="tasa_art"]').val();
	tasa = parseFloat(tasa).toFixed(2);
	var precio_bs = $('input[name="precio_bs_art"]').val();
	precio_bs = parseFloat(precio_bs).toFixed(2);
	var precio = precio_bs / tasa;
	precio = precio.toFixed(2);

	$('input[name="precio_d_art"]').val(precio);
//$('input[name="tasa"]').val(tasa);
}
$('input[name="tasa_art"]').change(function () {
	calc_bs_art();
});



//fill_tblar_compras
function fill_tblar_compras(data) {
	var subtotal_d = data["costo_d"];
	var costo = data["costo"];
	var tasa = $("#tasa").html();
	tasa = parseFloat(tasa).toFixed(2);

	var precio_bs = subtotal_d * tasa;
	precio_bs = parseFloat(precio_bs).toFixed(2);


	$("#tblar")
	.bootstrapTable("append", [
	{
		id_producto: data["id"],
		id_producto: data["id_producto"],
		codigo: data["codigo"],
		descripcion: data["descripcion"],
		stock: data["stock"],
		cantidad: "1",
		costo: data["costo"],
		precio_d: data["precio_d"],
		precio_bs: precio_bs,
		tasa: tasa,
		subtotal_d: subtotal_d,
		condicion: data["condicion"],
		categoria: data["categoria"],
	},
	])
	.data("2");


	var resultJSON2 = $("#tblarto").bootstrapTable("getData");
	var len3 = resultJSON2.length;
	if (len3 == 0) {
		$("#tblarto")
		.bootstrapTable("append", [
		{
			subtotal_d: "",
			iva: "",
			total_d: "",
		},
		])
		.data("2");
	}
	calc_to_tblar();
	epsToast(
		"info",
		"dark",
		'<i class="bi bi-hdd"></i>',
		"Item",
		"Send",
		"Articulo enviado a la tabla de trabajo",
		"bottom"
		);
}

//Input File Logo on Change cargar imagen en card
$("#file_input_foto").change(function () {
   readURL4(this);
});
function readURL4(input) {
   if (input.files && input.files[0]) {
      var reader = new FileReader();
      reader.onload = function (e) {
         $("#img_file_input_foto").attr("src", e.target.result);
      };
      reader.readAsDataURL(input.files[0]); // convert to base64 string
   }
}

//Input File Logo on Change cargar imagen en card
$("#file_input_foto_edit").change(function () {
   readURL5(this);
});
function readURL5(input) {
   if (input.files && input.files[0]) {
      var reader = new FileReader();
      reader.onload = function (e) {
         $("#img_file_input_foto_edit_ver").attr("src", e.target.result);
      };
      reader.readAsDataURL(input.files[0]); // convert to base64 string
   }
}

